/************************************************************************************/
/*  Program name CAPFAEXT_CAT_BOOK_DEF.sql                                          */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 22 DEC, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_CAT_BOOK_DEF';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_CAT_BOOK_DEF.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_CATEGORY_BOOK_DEFAULTS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.CATEGORY_ID||CHR(9)||
                C1.BOOK_TYPE_CODE||CHR(9)||
                C1.START_DPIS||CHR(9)||
                C1.END_DPIS||CHR(9)||
                C1.LIFE_IN_MONTHS||CHR(9)||
                C1.DEPRN_METHOD||CHR(9)||
                C1.PRORATE_CONVENTION_CODE||CHR(9)||
                C1.ITC_ELIGIBLE_FLAG||CHR(9)||
                C1.USE_ITC_CEILINGS_FLAG||CHR(9)||
                C1.CEILING_NAME||CHR(9)||
                C1.BASIC_RATE||CHR(9)||
                C1.ADJUSTED_RATE||CHR(9)||
                C1.BONUS_RULE||CHR(9)||
                C1.DEPRECIATE_FLAG||CHR(9)||
                C1.RETIREMENT_PRORATE_CONVENTION||CHR(9)||
                C1.PRICE_INDEX_NAME||CHR(9)||
                C1.USE_STL_RETIREMENTS_FLAG||CHR(9)||
                C1.STL_METHOD_CODE||CHR(9)||
                C1.STL_LIFE_IN_MONTHS||CHR(9)||
                C1.LAST_UPDATE_DATE||CHR(9)||
                C1.LAST_UPDATED_BY||CHR(9)||
                C1.CREATED_BY||CHR(9)||
                C1.CREATION_DATE||CHR(9)||
                C1.LAST_UPDATE_LOGIN||CHR(9)||
                C1.SUBCOMPONENT_LIFE_RULE||CHR(9)||
                C1.MINIMUM_LIFE_IN_MONTHS||CHR(9)||
                C1.PRODUCTION_CAPACITY||CHR(9)||
                C1.UNIT_OF_MEASURE||CHR(9)||
                C1.CAPITAL_GAIN_THRESHOLD||CHR(9)||
                C1.ATTRIBUTE1||CHR(9)||
                C1.ATTRIBUTE2||CHR(9)||
                C1.ATTRIBUTE3||CHR(9)||
                C1.ATTRIBUTE4||CHR(9)||
                C1.ATTRIBUTE5||CHR(9)||
                C1.ATTRIBUTE6||CHR(9)||
                C1.ATTRIBUTE7||CHR(9)||
                C1.ATTRIBUTE8||CHR(9)||
                C1.ATTRIBUTE9||CHR(9)||
                C1.ATTRIBUTE10||CHR(9)||
                C1.ATTRIBUTE11||CHR(9)||
                C1.ATTRIBUTE12||CHR(9)||
                C1.ATTRIBUTE13||CHR(9)||
                C1.ATTRIBUTE14||CHR(9)||
                C1.ATTRIBUTE15||CHR(9)||
                C1.ATTRIBUTE_CATEGORY_CODE||CHR(9)||
                C1.USE_DEPRN_LIMITS_FLAG||CHR(9)||
                C1.ALLOWED_DEPRN_LIMIT||CHR(9)||
                C1.SPECIAL_DEPRN_LIMIT_AMOUNT||CHR(9)||
                C1.PERCENT_SALVAGE_VALUE||CHR(9)||
                C1.CUA_LIFE_END_DATE||CHR(9)||
                C1.CUA_RULE_SET_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
